--- doxygen-1.7.2/src/index.cpp	2010-10-03 15:05:55.000000000 +0200
+++ doxygen-1.7.2-patched/src/index.cpp	2011-01-02 23:08:53.000000000 +0100
@@ -697,6 +697,7 @@
   endTitle(ol,0,0);
   ol.startContents();
   ol.startTextBlock();
+  ol.startParagraph();
   Doxygen::indexList.addContentsItem(TRUE,title,0,"hierarchy",0); 
   if (Config_getBool("HAVE_DOT") && Config_getBool("GRAPHICAL_HIERARCHY"))
   {
@@ -711,6 +712,7 @@
     ol.enable(OutputGenerator::RTF);
   }
   ol.parseText(theTranslator->trClassHierarchyDescription());
+  ol.endParagraph();
   ol.endTextBlock();
 
   FTVHelp* ftv = 0;
@@ -820,9 +822,11 @@
   endTitle(ol,0,0);
   ol.startContents();
   ol.startTextBlock();
+  ol.startParagraph();
   Doxygen::indexList.addContentsItem(TRUE,theTranslator->trFileList(),0,"files",0); 
   Doxygen::indexList.incContentsDepth();
   ol.parseText(theTranslator->trFileListDescription(Config_getBool("EXTRACT_ALL")));
+  ol.endParagraph();
   ol.endTextBlock();
 
   OutputNameDict outputNameDict(1009);
@@ -1006,6 +1010,7 @@
   endTitle(ol,0,0);
   ol.startContents();
   ol.startTextBlock();
+  ol.startParagraph();
   Doxygen::indexList.addContentsItem(TRUE,title,0,"namespaces",0); 
   Doxygen::indexList.incContentsDepth();
   //ol.newParagraph();
@@ -1022,6 +1027,7 @@
     ol.parseText(theTranslator->trNamespaceListDescription(Config_getBool("EXTRACT_ALL")));
   }
   //ol.newParagraph();
+  ol.endParagraph();
   ol.endTextBlock();
 
   bool first=TRUE;
@@ -1480,12 +1486,14 @@
   endTitle(ol,0,0);
   ol.startContents();
   ol.startTextBlock();
+  ol.startParagraph();
   Doxygen::indexList.addContentsItem(TRUE,title,0,"annotated",0); 
   Doxygen::indexList.incContentsDepth();
   QCString desc = fortranOpt ? theTranslator->trCompoundListDescriptionFortran() :
                   vhdlOpt    ? VhdlDocGen::trDesignUnitListDescription()             :
                                theTranslator->trCompoundListDescription()        ;
   ol.parseText(desc);
+  ol.endParagraph();
   ol.endTextBlock();
   writeAnnotatedClassList(ol);
   Doxygen::indexList.decContentsDepth();
@@ -1972,7 +1980,7 @@
 
       ol.endQuickIndices();
       ol.startContents();
-
+      ol.startParagraph();
       if (hl==CMHL_All)
       {
         static bool extractAll = Config_getBool("EXTRACT_ALL");
@@ -1986,6 +1994,7 @@
         ol.writeString("&#160;");
       }
       //ol.newParagraph();  // FIXME:PARA
+      ol.endParagraph();
       writeMemberList(ol,quickIndex,
                       multiPageIndex?page:-1,
                       g_memberIndexLetterUsed[hl],
@@ -2105,6 +2114,7 @@
 
       ol.endQuickIndices();
       ol.startContents();
+      ol.startParagraph();
 
       if (hl==FMHL_All)
       {
@@ -2116,6 +2126,7 @@
         // normal lists otherwise
         ol.writeString("&#160;");
       }
+      ol.endParagraph();
       //ol.newParagraph();  // FIXME:PARA
       //writeFileMemberList(ol,quickIndex,hl,page);
       writeMemberList(ol,quickIndex,
@@ -2947,10 +2958,12 @@
   endTitle(ol,0,0);
   ol.startContents();
   ol.startTextBlock();
+  ol.startParagraph();
   Doxygen::indexList.addContentsItem(TRUE,theTranslator->trExamples(),0,"examples",0); 
   Doxygen::indexList.incContentsDepth();
   ol.parseText(theTranslator->trExamplesDescription());
   //ol.newParagraph();
+  ol.endParagraph();
   ol.endTextBlock();
   ol.startItemList();
   PageSDict::Iterator pdi(*Doxygen::exampleSDict);
@@ -3045,9 +3058,11 @@
   endTitle(ol,0,0);
   ol.startContents();
   ol.startTextBlock();
+  ol.startParagraph();
   //Doxygen::indexList.addContentsItem(TRUE,theTranslator->trRelatedPages(),0,"pages",0); 
   //Doxygen::indexList.incContentsDepth();
   ol.parseText(theTranslator->trRelatedPagesDescription());
+  ol.endParagraph();
   ol.endTextBlock();
   startIndexHierarchy(ol,0);
   PageSDict::Iterator pdi(*Doxygen::pageSDict);
@@ -3508,9 +3523,11 @@
   endTitle(ol,0,0);
   ol.startContents();
   ol.startTextBlock();
+  ol.startParagraph();
   Doxygen::indexList.addContentsItem(TRUE,theTranslator->trModules(),0,"modules",0); 
   Doxygen::indexList.incContentsDepth();
   ol.parseText(theTranslator->trModulesDescription());
+  ol.endParagraph();
   ol.endTextBlock();
 
   FTVHelp* ftv = 0;
@@ -3556,9 +3573,11 @@
   endTitle(ol,0,0);
   ol.startContents();
   ol.startTextBlock();
+  ol.startParagraph();
   Doxygen::indexList.addContentsItem(TRUE,theTranslator->trDirIndex(),0,"dirs",0); 
   Doxygen::indexList.incContentsDepth();
   ol.parseText(theTranslator->trDirDescription());
+  ol.endParagraph();
   ol.endTextBlock();
 
   FTVHelp* ftv = 0;
@@ -3904,9 +3923,11 @@
     startFile(ol,Doxygen::mainPage->name(),0,Doxygen::mainPage->title());
     ol.startContents();
     ol.startTextBlock();
+    ol.startParagraph();
     ol.parseDoc(defFileName,defLine,Doxygen::mainPage,0,
                 Doxygen::mainPage->documentation(),FALSE,FALSE
                );
+    ol.endParagraph();
     ol.endTextBlock();
     endFile(ol);
     ol.enable(OutputGenerator::Man);