diff -ur Release_1_7_4_20110426/src/groupdef.cpp Release_1_7_4_20110426.new/src/groupdef.cpp
--- Release_1_7_4_20110426/src/groupdef.cpp	2011-04-26 12:50:36.000000000 +0200
+++ Release_1_7_4_20110426.new/src/groupdef.cpp	2011-06-04 05:23:07.533724859 +0200
@@ -860,7 +860,11 @@
   ol.disable(OutputGenerator::Man);
   ol.parseText(title);
   ol.popGeneratorState();
-  ol.endTitleHead(getOutputFileBase(),title);
+  ol.endTitleHead(getOutputFileBase(),name(),title);
+  ol.pushGeneratorState();
+  ol.disableAllBut(OutputGenerator::Man);
+  ol.parseText(title);
+  ol.popGeneratorState();
   addGroupListToTitle(ol,this);
   ol.endHeaderSection();
   ol.startContents();
diff -ur Release_1_7_4_20110426/src/htmlgen.cpp Release_1_7_4_20110426.new/src/htmlgen.cpp
--- Release_1_7_4_20110426/src/htmlgen.cpp	2011-04-26 12:50:36.000000000 +0200
+++ Release_1_7_4_20110426.new/src/htmlgen.cpp	2011-06-04 05:20:42.934662567 +0200
@@ -3175,7 +3175,7 @@
   startTitle(); 
 }
 
-void HtmlGenerator::endTitleHead(const char *,const char *) 
+void HtmlGenerator::endTitleHead(const char *,const char *,const char *)
 { 
   endTitle(); 
   t << "  </div>" << endl;
diff -ur Release_1_7_4_20110426/src/htmlgen.h Release_1_7_4_20110426.new/src/htmlgen.h
--- Release_1_7_4_20110426/src/htmlgen.h	2011-04-26 12:50:36.000000000 +0200
+++ Release_1_7_4_20110426.new/src/htmlgen.h	2011-06-04 05:20:42.948662380 +0200
@@ -66,7 +66,7 @@
     void endProjectNumber();
     void writeStyleInfo(int part);
     void startTitleHead(const char *);
-    void endTitleHead(const char *,const char *);
+    void endTitleHead(const char *,const char *,const char *);
     void startTitle() { t << "<div class=\"title\">"; }
     void endTitle() { t << "</div>"; }
     
diff -ur Release_1_7_4_20110426/src/index.cpp Release_1_7_4_20110426.new/src/index.cpp
--- Release_1_7_4_20110426/src/index.cpp	2011-04-26 12:50:36.000000000 +0200
+++ Release_1_7_4_20110426.new/src/index.cpp	2011-06-04 05:20:42.957662259 +0200
@@ -288,7 +288,7 @@
 void endTitle(OutputList &ol,const char *fileName,const char *name)
 {
   ol.popGeneratorState();
-  ol.endTitleHead(fileName,name);
+  ol.endTitleHead(fileName,name,name);
   ol.endHeaderSection();
 }
 
@@ -3930,7 +3930,7 @@
   }
   if (headerWritten)
   {
-    ol.endTitleHead(0,0);
+    ol.endTitleHead(0,0,0);
     ol.endHeaderSection();
   }
   ol.startContents();
diff -ur Release_1_7_4_20110426/src/latexgen.cpp Release_1_7_4_20110426.new/src/latexgen.cpp
--- Release_1_7_4_20110426/src/latexgen.cpp	2011-04-26 12:50:36.000000000 +0200
+++ Release_1_7_4_20110426.new/src/latexgen.cpp	2011-06-04 05:20:43.010661549 +0200
@@ -1517,7 +1517,7 @@
   }
 }
 
-void LatexGenerator::endTitleHead(const char *fileName,const char *name)
+void LatexGenerator::endTitleHead(const char *fileName,const char *,const char *name)
 {
   static bool pdfHyperlinks = Config_getBool("PDF_HYPERLINKS");
   static bool usePDFLatex   = Config_getBool("USE_PDFLATEX");
diff -ur Release_1_7_4_20110426/src/latexgen.h Release_1_7_4_20110426.new/src/latexgen.h
--- Release_1_7_4_20110426/src/latexgen.h	2011-04-26 12:50:36.000000000 +0200
+++ Release_1_7_4_20110426.new/src/latexgen.h	2011-06-04 05:20:43.017661456 +0200
@@ -59,7 +59,7 @@
     void writeStyleInfo(int part);
     void startTitleHead(const char *);
     void startTitle();
-    void endTitleHead(const char *,const char *name);
+    void endTitleHead(const char *,const char *,const char *name);
     void endTitle()   { t << "}"; }
 
     void newParagraph();
diff -ur Release_1_7_4_20110426/src/mangen.cpp Release_1_7_4_20110426.new/src/mangen.cpp
--- Release_1_7_4_20110426/src/mangen.cpp	2011-04-26 12:50:36.000000000 +0200
+++ Release_1_7_4_20110426.new/src/mangen.cpp	2011-06-04 05:25:26.834859092 +0200
@@ -150,7 +150,7 @@
   endPlainFile();
 }
 
-void ManGenerator::endTitleHead(const char *,const char *name)
+void ManGenerator::endTitleHead(const char *,const char *manName,const char *name)
 {
   t << ".TH \"" << name << "\" " << getExtension() << " \"" 
     << dateToString(FALSE) << "\" \"";
@@ -164,7 +164,7 @@
   t << ".ad l" << endl;
   t << ".nh" << endl;
   t << ".SH NAME" << endl;
-  t << name << " \\- ";
+  t << manName << " \\- ";
   firstCol=FALSE;
   inHeader=TRUE;
 }
diff -ur Release_1_7_4_20110426/src/mangen.h Release_1_7_4_20110426.new/src/mangen.h
--- Release_1_7_4_20110426/src/mangen.h	2011-04-26 12:50:36.000000000 +0200
+++ Release_1_7_4_20110426.new/src/mangen.h	2011-06-04 05:20:43.034661228 +0200
@@ -55,7 +55,7 @@
     void endProjectNumber() {}
     void writeStyleInfo(int) {}
     void startTitleHead(const char *) {}
-    void endTitleHead(const char *,const char *);
+    void endTitleHead(const char *,const char *,const char *);
     void startTitle();
     void endTitle();
     
diff -ur Release_1_7_4_20110426/src/outputgen.h Release_1_7_4_20110426.new/src/outputgen.h
--- Release_1_7_4_20110426/src/outputgen.h	2011-04-26 12:50:36.000000000 +0200
+++ Release_1_7_4_20110426.new/src/outputgen.h	2011-06-04 05:20:43.041661135 +0200
@@ -310,7 +310,7 @@
     virtual void endProjectNumber() = 0;
     virtual void writeStyleInfo(int part) = 0;
     virtual void startTitleHead(const char *) = 0;
-    virtual void endTitleHead(const char *fileName,const char *name) = 0;
+    virtual void endTitleHead(const char *fileName,const char *manName,const char *name) = 0;
     virtual void startIndexListItem() = 0;
     virtual void endIndexListItem()   = 0;
     virtual void startIndexList() = 0;
diff -ur Release_1_7_4_20110426/src/outputlist.h Release_1_7_4_20110426.new/src/outputlist.h
--- Release_1_7_4_20110426/src/outputlist.h	2011-04-26 12:50:36.000000000 +0200
+++ Release_1_7_4_20110426.new/src/outputlist.h	2011-06-04 05:20:43.050661014 +0200
@@ -91,8 +91,8 @@
     { forall(&OutputGenerator::endFile); }
     void startTitleHead(const char *fileName) 
     { forall(&OutputGenerator::startTitleHead,fileName); }
-    void endTitleHead(const char *fileName,const char *name)
-    { forall(&OutputGenerator::endTitleHead,fileName,name); }
+    void endTitleHead(const char *fileName,const char *manName,const char *name)
+    { forall(&OutputGenerator::endTitleHead,fileName,manName,name); }
     void startTitle() 
     { forall(&OutputGenerator::startTitle); }
     void endTitle() 
diff -ur Release_1_7_4_20110426/src/pagedef.cpp Release_1_7_4_20110426.new/src/pagedef.cpp
--- Release_1_7_4_20110426/src/pagedef.cpp	2011-04-26 12:50:36.000000000 +0200
+++ Release_1_7_4_20110426.new/src/pagedef.cpp	2011-06-04 05:20:43.057660919 +0200
@@ -109,7 +109,7 @@
   //2.{
   ol.disableAllBut(OutputGenerator::Man);
   ol.startTitleHead(pageName);
-  ol.endTitleHead(pageName, pageName);
+  ol.endTitleHead(pageName, pageName, pageName);
   if (si)
   {
     ol.parseDoc(docFile(),docLine(),this,0,si->title,TRUE,FALSE,0,TRUE,FALSE);
diff -ur Release_1_7_4_20110426/src/rtfgen.cpp Release_1_7_4_20110426.new/src/rtfgen.cpp
--- Release_1_7_4_20110426/src/rtfgen.cpp	2011-04-26 12:50:36.000000000 +0200
+++ Release_1_7_4_20110426.new/src/rtfgen.cpp	2011-06-04 05:20:43.099660357 +0200
@@ -1384,7 +1384,7 @@
   t << rtf_Style_Reset << rtf_Style["Heading2"]->reference << endl;
 }
 
-void RTFGenerator::endTitleHead(const char *fileName,const char *name)
+void RTFGenerator::endTitleHead(const char *fileName,const char *,const char *name)
 {
   DBG_RTF(t <<"{\\comment endTitleHead}" << endl)
   t << "\\par " << rtf_Style_Reset << endl;
diff -ur Release_1_7_4_20110426/src/rtfgen.h Release_1_7_4_20110426.new/src/rtfgen.h
--- Release_1_7_4_20110426/src/rtfgen.h	2011-04-26 12:50:36.000000000 +0200
+++ Release_1_7_4_20110426.new/src/rtfgen.h	2011-06-04 05:20:43.107660249 +0200
@@ -56,7 +56,7 @@
     void writeStyleInfo(int part);
     void startTitleHead(const char *);
     void startTitle();
-    void endTitleHead(const char *,const char *name);
+    void endTitleHead(const char *,const char *,const char *name);
     void endTitle() {} 
 
     void newParagraph();