Index: dot.cpp
===================================================================
RCS file: /cygdrive/d/cvs_doxygen/doxygen/doxygen/src/dot.cpp,v
retrieving revision 1.3
diff -u -r1.3 dot.cpp
--- dot.cpp	14 Jun 2012 16:56:51 -0000	1.3
+++ dot.cpp	16 Jun 2012 17:22:18 -0000
@@ -232,10 +232,17 @@
   return dotFontSize;
 }
 
-static void writeGraphHeader(FTextStream &t)
+static void writeGraphHeader(FTextStream &t, QCString title)
 {
   static bool interactiveSVG = Config_getBool("INTERACTIVE_SVG");
-  t << "digraph G" << endl;
+  if (strlen(title.data()) == 0)
+  {
+    t << "digraph G" << endl;
+  }
+  else
+  {
+    t << "digraph \""+title+"\"" << endl;
+  }
   t << "{" << endl;
   if (interactiveSVG) // insert a comment to force regeneration when this
                       // option is toggled
@@ -2197,7 +2204,7 @@
     // compute md5 checksum of the graph were are about to generate
     QGString theGraph;
     FTextStream md5stream(&theGraph);
-    writeGraphHeader(md5stream);
+    writeGraphHeader(md5stream, "");
     md5stream << "  rankdir=\"LR\";" << endl;
     for (dnli2.toFirst();(node=dnli2.current());++dnli2)
     {
@@ -2861,7 +2868,8 @@
                    bool lrRank,
                    bool renderParents,
                    bool backArrows,
-                   QCString &graphStr
+                   QCString &graphStr,
+                   QCString title
                   )
 {
   bool reNumber=TRUE;
@@ -2869,7 +2877,7 @@
   //printf("computeMd5Signature\n");
   QGString buf;
   FTextStream md5stream(&buf);
-  writeGraphHeader(md5stream);
+  writeGraphHeader(md5stream, title);
   if (lrRank)
   {
     md5stream << "  rankdir=\"LR\";" << endl;
@@ -2930,13 +2938,14 @@
                            GraphOutputFormat format,
                            bool lrRank,
                            bool renderParents,
-                           bool backArrows
+                           bool backArrows,
+                           QCString title
                           )
 {
   QCString theGraph;
   // TODO: write graph to theGraph, then compute md5 checksum
   QCString md5 = computeMd5Signature(
-                   root,gt,format,lrRank,renderParents,backArrows,theGraph);
+                   root,gt,format,lrRank,renderParents,backArrows,theGraph,title);
   QFile f(baseName+".dot");
   if (f.open(IO_WriteOnly))
   {
@@ -3019,7 +3028,8 @@
                  format,
                  m_lrRank,
                  m_graphType==DotNode::Inheritance,
-                 TRUE
+                 TRUE,
+                 ""
                 ) ||
       !checkDeliverables(format==BITMAP ? absImgName : 
                          usePDFLatex    ? absPdfName : absEpsName,
@@ -3339,7 +3349,8 @@
                  format,
                  FALSE,        // lrRank
                  FALSE,        // renderParents
-                 m_inverse     // backArrows
+                 m_inverse,    // backArrows,
+                 ""
                 ) ||
       !checkDeliverables(format==BITMAP ? absImgName :
                          usePDFLatex ? absPdfName : absEpsName,
@@ -3600,7 +3611,7 @@
 QCString DotCallGraph::writeGraph(FTextStream &out, GraphOutputFormat format,
                         const char *path,const char *fileName,
                         const char *relPath,bool generateImageMap,int
-                        graphId) const
+                        graphId, QCString title) const
 {
   QDir d(path);
   // store the original directory
@@ -3628,7 +3639,8 @@
                  format,
                  TRUE,         // lrRank
                  FALSE,        // renderParents
-                 m_inverse     // backArrows
+                 m_inverse,    // backArrows
+                 title
                 ) ||
       !checkDeliverables(format==BITMAP ? absImgName :
                          usePDFLatex ? absPdfName : absEpsName,
@@ -3873,7 +3885,7 @@
 
   QGString theGraph;
   FTextStream md5stream(&theGraph);
-  writeGraphHeader(md5stream);
+  writeGraphHeader(md5stream, "");
   md5stream << "  Node9 [shape=\"box\",label=\"Inherited\",fontsize=\"" << FONTSIZE << "\",height=0.2,width=0.4,fontname=\"" << FONTNAME << "\",fillcolor=\"grey75\",style=\"filled\" fontcolor=\"black\"];\n";
   md5stream << "  Node10 -> Node9 [dir=\"back\",color=\"midnightblue\",fontsize=\"" << FONTSIZE << "\",style=\"solid\",fontname=\"" << FONTNAME << "\"];\n";
   md5stream << "  Node10 [shape=\"box\",label=\"PublicBase\",fontsize=\"" << FONTSIZE << "\",height=0.2,width=0.4,fontname=\"" << FONTNAME << "\",color=\"black\",URL=\"$classPublicBase" << Doxygen::htmlFileExtension << "\"];\n";
@@ -4254,7 +4266,7 @@
 
 QCString DotGroupCollaboration::writeGraph( FTextStream &t, GraphOutputFormat format,
     const char *path, const char *fileName, const char *relPath,
-    bool writeImageMap,int graphId) const
+    bool writeImageMap,int graphId, QCString title) const
 {
   QDir d(path);
   // store the original directory
@@ -4266,7 +4278,7 @@
 
   QGString theGraph;
   FTextStream md5stream(&theGraph);
-  writeGraphHeader(md5stream);
+  writeGraphHeader(md5stream, title);
 
   // clean write flags
   QDictIterator<DotNode> dni(*m_usedNodes);
@@ -4463,7 +4475,7 @@
   return m_usedNodes->count() <= 1;
 }
 
-void DotGroupCollaboration::writeGraphHeader(FTextStream &t) const
+void DotGroupCollaboration::writeGraphHeader(FTextStream &t, QCString title) const
 {
   t << "digraph structs" << endl;
   t << "{" << endl;
Index: dot.h
===================================================================
RCS file: /cygdrive/d/cvs_doxygen/doxygen/doxygen/src/dot.h,v
retrieving revision 1.2
diff -u -r1.2 dot.h
--- dot.h	14 Jun 2012 16:56:51 -0000	1.2
+++ dot.h	16 Jun 2012 17:15:52 -0000
@@ -127,7 +127,8 @@
                       GraphOutputFormat f, 
                       bool lrRank, bool renderParents,
                       bool backArrows,
-                      QCString &graphStr
+                      QCString &graphStr,
+                      QCString title
                      );
 };
 
@@ -224,7 +225,7 @@
     QCString writeGraph(FTextStream &t, GraphOutputFormat f,
                         const char *path,const char *fileName,
                         const char *relPath,bool writeImageMap=TRUE,
-                        int graphId=-1) const;
+                        int graphId=-1, QCString title = "") const;
     void buildGraph(DotNode *n,MemberDef *md,int distance);
     bool isTrivial() const;
     bool isTooBig() const;
@@ -301,13 +302,13 @@
     ~DotGroupCollaboration();
     QCString writeGraph(FTextStream &t, GraphOutputFormat format,
                     const char *path,const char *fileName,const char *relPath,
-                    bool writeImageMap=TRUE,int graphId=-1) const;
+                    bool writeImageMap=TRUE,int graphId=-1, QCString title = "") const;
     void buildGraph(GroupDef* gd);
     bool isTrivial() const;
   private :
     void addCollaborationMember( Definition* def, QCString& url, EdgeType eType );
     void addMemberList( class MemberList* ml );
-    void writeGraphHeader(FTextStream &t) const;
+    void writeGraphHeader(FTextStream &t, QCString title = "") const;
     Edge* addEdge( DotNode* _pNStart, DotNode* _pNEnd, EdgeType _eType,
                    const QCString& _label, const QCString& _url );
 
Index: htmlgen.cpp
===================================================================
RCS file: /cygdrive/d/cvs_doxygen/doxygen/doxygen/src/htmlgen.cpp,v
retrieving revision 1.2
diff -u -r1.2 htmlgen.cpp
--- htmlgen.cpp	14 Jun 2012 16:56:52 -0000	1.2
+++ htmlgen.cpp	16 Jun 2012 17:22:08 -0000
@@ -2296,14 +2296,14 @@
   startSectionHeader(t,relPath,m_sectionCount);
 }
 
-void HtmlGenerator::endCallGraph(const DotCallGraph &g)
+void HtmlGenerator::endCallGraph(const DotCallGraph &g, QCString title)
 {
   endSectionHeader(t);
   startSectionSummary(t,m_sectionCount);
   endSectionSummary(t);
   startSectionContent(t,m_sectionCount);
 
-  g.writeGraph(t,BITMAP,dir,fileName,relPath,TRUE,m_sectionCount);
+  g.writeGraph(t,BITMAP,dir,fileName,relPath,TRUE,m_sectionCount,title);
 
   endSectionContent(t);
   m_sectionCount++;
Index: htmlgen.h
===================================================================
RCS file: /cygdrive/d/cvs_doxygen/doxygen/doxygen/src/htmlgen.h,v
retrieving revision 1.2
diff -u -r1.2 htmlgen.h
--- htmlgen.h	14 Jun 2012 16:56:52 -0000	1.2
+++ htmlgen.h	16 Jun 2012 13:41:33 -0000
@@ -229,7 +229,7 @@
     void startGroupCollaboration();
     void endGroupCollaboration(const DotGroupCollaboration &g);
     void startCallGraph();
-    void endCallGraph(const DotCallGraph &g);
+    void endCallGraph(const DotCallGraph &g, QCString title = "");
     void startDirDepGraph();
     void endDirDepGraph(const DotDirDeps &g);
     void writeGraphicalHierarchy(const DotGfxHierarchyTable &g);
Index: latexgen.cpp
===================================================================
RCS file: /cygdrive/d/cvs_doxygen/doxygen/doxygen/src/latexgen.cpp,v
retrieving revision 1.1
diff -u -r1.1 latexgen.cpp
--- latexgen.cpp	22 May 2012 19:36:45 -0000	1.1
+++ latexgen.cpp	16 Jun 2012 13:54:29 -0000
@@ -2256,7 +2256,7 @@
 {
 }
 
-void LatexGenerator::endCallGraph(const DotCallGraph &g) 
+void LatexGenerator::endCallGraph(const DotCallGraph &g, QCString title)
 {
   g.writeGraph(t,EPS,Config_getString("LATEX_OUTPUT"),fileName,relPath);
 }
Index: latexgen.h
===================================================================
RCS file: /cygdrive/d/cvs_doxygen/doxygen/doxygen/src/latexgen.h,v
retrieving revision 1.2
diff -u -r1.2 latexgen.h
--- latexgen.h	14 Jun 2012 16:56:53 -0000	1.2
+++ latexgen.h	16 Jun 2012 13:54:41 -0000
@@ -214,7 +214,7 @@
     void startCallGraph();
     void startGroupCollaboration();
     void endGroupCollaboration(const DotGroupCollaboration &g);
-    void endCallGraph(const DotCallGraph &);
+    void endCallGraph(const DotCallGraph &g, QCString title = "");
     void startDirDepGraph();
     void endDirDepGraph(const DotDirDeps &g);
     void writeGraphicalHierarchy(const DotGfxHierarchyTable &) {}
Index: mangen.h
===================================================================
RCS file: /cygdrive/d/cvs_doxygen/doxygen/doxygen/src/mangen.h,v
retrieving revision 1.2
diff -u -r1.2 mangen.h
--- mangen.h	14 Jun 2012 16:56:53 -0000	1.2
+++ mangen.h	16 Jun 2012 16:31:01 -0000
@@ -206,7 +206,7 @@
     void startGroupCollaboration() {}
     void endGroupCollaboration(const DotGroupCollaboration &) {}
     void startCallGraph() {}
-    void endCallGraph(const DotCallGraph &) {}
+    void endCallGraph(const DotCallGraph &g, QCString title = "") {};
     void startDirDepGraph() {} 
     void endDirDepGraph(const DotDirDeps &) {}
     void writeGraphicalHierarchy(const DotGfxHierarchyTable &) {}
Index: memberdef.cpp
===================================================================
RCS file: /cygdrive/d/cvs_doxygen/doxygen/doxygen/src/memberdef.cpp,v
retrieving revision 1.2
diff -u -r1.2 memberdef.cpp
--- memberdef.cpp	14 Jun 2012 16:56:53 -0000	1.2
+++ memberdef.cpp	16 Jun 2012 14:12:51 -0000
@@ -1895,7 +1895,7 @@
       ol.startParagraph();
       ol.startCallGraph();
       ol.parseText(theTranslator->trCallGraph());
-      ol.endCallGraph(callGraph);
+      ol.endCallGraph(callGraph, theTranslator->trCallGraphGraph() +" " + qPrint(qualifiedName()));
       ol.endParagraph(); 
       ol.enableAll();
     }
@@ -1920,7 +1920,7 @@
       ol.startParagraph();
       ol.startCallGraph();
       ol.parseText(theTranslator->trCallerGraph());
-      ol.endCallGraph(callerGraph);
+      ol.endCallGraph(callerGraph, theTranslator->trCallerGraphGraph() +" " + qPrint(qualifiedName()));
       ol.endParagraph();
       ol.enableAll();
     }
Index: outputgen.h
===================================================================
RCS file: /cygdrive/d/cvs_doxygen/doxygen/doxygen/src/outputgen.h,v
retrieving revision 1.2
diff -u -r1.2 outputgen.h
--- outputgen.h	14 Jun 2012 16:56:54 -0000	1.2
+++ outputgen.h	16 Jun 2012 13:44:13 -0000
@@ -379,7 +379,7 @@
     virtual void startGroupCollaboration() = 0;
     virtual void endGroupCollaboration(const DotGroupCollaboration &g) = 0;
     virtual void startCallGraph() = 0;
-    virtual void endCallGraph(const DotCallGraph &g) = 0;
+    virtual void endCallGraph(const DotCallGraph &g, QCString title) = 0;
     virtual void startDirDepGraph() = 0;
     virtual void endDirDepGraph(const DotDirDeps &g) = 0;
     virtual void writeGraphicalHierarchy(const DotGfxHierarchyTable &g) = 0;
Index: outputlist.cpp
===================================================================
RCS file: /cygdrive/d/cvs_doxygen/doxygen/doxygen/src/outputlist.cpp,v
retrieving revision 1.2
diff -u -r1.2 outputlist.cpp
--- outputlist.cpp	14 Jun 2012 16:56:54 -0000	1.2
+++ outputlist.cpp	16 Jun 2012 16:29:52 -0000
@@ -292,7 +292,7 @@
 FORALL1(int a1,a1)
 FORALL1(const DotClassGraph &a1,a1)
 FORALL1(const DotInclDepGraph &a1,a1)
-FORALL1(const DotCallGraph &a1,a1)
+FORALL2(const DotCallGraph &a1, QCString a2, a1, a2)
 FORALL1(const DotDirDeps &a1,a1)
 FORALL1(const DotGfxHierarchyTable &a1,a1)
 FORALL1(const DotGroupCollaboration &a1,a1)
Index: outputlist.h
===================================================================
RCS file: /cygdrive/d/cvs_doxygen/doxygen/doxygen/src/outputlist.h,v
retrieving revision 1.2
diff -u -r1.2 outputlist.h
--- outputlist.h	14 Jun 2012 16:56:54 -0000	1.2
+++ outputlist.h	16 Jun 2012 13:52:26 -0000
@@ -378,8 +378,8 @@
     { forall(&OutputGenerator::endInclDepGraph,g); }
     void startCallGraph()
     { forall(&OutputGenerator::startCallGraph); }
-    void endCallGraph(const DotCallGraph &g)
-    { forall(&OutputGenerator::endCallGraph,g); }
+    void endCallGraph(const DotCallGraph &g, QCString title)
+    { forall(&OutputGenerator::endCallGraph,g,title); }
     void startDirDepGraph()
     { forall(&OutputGenerator::startDirDepGraph); }
     void endDirDepGraph(const DotDirDeps &g)
@@ -497,7 +497,7 @@
     FORALLPROTO1(int);
     FORALLPROTO1(const DotClassGraph &);
     FORALLPROTO1(const DotInclDepGraph &);
-    FORALLPROTO1(const DotCallGraph &);
+    FORALLPROTO2(const DotCallGraph &g, QCString title);
     FORALLPROTO1(const DotGroupCollaboration &);
     FORALLPROTO1(const DotDirDeps &);
     FORALLPROTO1(const DotGfxHierarchyTable &);
Index: rtfgen.cpp
===================================================================
RCS file: /cygdrive/d/cvs_doxygen/doxygen/doxygen/src/rtfgen.cpp,v
retrieving revision 1.1
diff -u -r1.1 rtfgen.cpp
--- rtfgen.cpp	22 May 2012 19:36:52 -0000	1.1
+++ rtfgen.cpp	16 Jun 2012 13:55:28 -0000
@@ -2464,7 +2464,7 @@
   DBG_RTF(t << "{\\comment (startCallGraph)}"    << endl)
 }
 
-void RTFGenerator::endCallGraph(const DotCallGraph &g)
+void RTFGenerator::endCallGraph(const DotCallGraph &g, QCString title)
 {
   newParagraph();
 
Index: rtfgen.h
===================================================================
RCS file: /cygdrive/d/cvs_doxygen/doxygen/doxygen/src/rtfgen.h,v
retrieving revision 1.2
diff -u -r1.2 rtfgen.h
--- rtfgen.h	14 Jun 2012 16:56:54 -0000	1.2
+++ rtfgen.h	16 Jun 2012 13:55:38 -0000
@@ -201,7 +201,7 @@
     void startGroupCollaboration();
     void endGroupCollaboration(const DotGroupCollaboration &g);
     void startCallGraph();
-    void endCallGraph(const DotCallGraph &);
+    void endCallGraph(const DotCallGraph &g, QCString title = "");
     void startDirDepGraph();
     void endDirDepGraph(const DotDirDeps &g);
     void writeGraphicalHierarchy(const DotGfxHierarchyTable &) {}
Index: translator.h
===================================================================
RCS file: /cygdrive/d/cvs_doxygen/doxygen/doxygen/src/translator.h,v
retrieving revision 1.2
diff -u -r1.2 translator.h
--- translator.h	14 Jun 2012 16:56:54 -0000	1.2
+++ translator.h	16 Jun 2012 14:13:08 -0000
@@ -518,6 +518,11 @@
     virtual QCString trInheritedFrom(const char *members,const char *what) = 0;
     virtual QCString trAdditionalInheritedMembers() = 0;
 
+//////////////////////////////////////////////////////////////////////////
+// new since 1.8.2
+//////////////////////////////////////////////////////////////////////////
+    virtual QCString trCallerGraphGraph() = 0;
+    virtual QCString trCallGraphGraph() = 0;
 };
 
 #endif
Index: translator_adapter.h
===================================================================
RCS file: /cygdrive/d/cvs_doxygen/doxygen/doxygen/src/translator_adapter.h,v
retrieving revision 1.2
diff -u -r1.2 translator_adapter.h
--- translator_adapter.h	14 Jun 2012 16:56:54 -0000	1.2
+++ translator_adapter.h	16 Jun 2012 14:28:48 -0000
@@ -41,9 +41,25 @@
 };
 
 /** Adapter class for languages that only contain translations upto 
+ *  version 1.8.2. 
+ */
+class TranslatorAdapter_1_8_2 : public TranslatorAdapterBase
+{
+  public:
+    virtual QCString updateNeededMessage()
+    { return createUpdateNeededMessage(idLanguage(),"release 1.8.2"); }
+
+    virtual QCString trCallGraphGraph()
+    { return english.trCallGraphGraph(); }
+
+    virtual QCString trCallerGraphGraph()
+    { return english.trCallerGraphGraph(); }
+};
+
+/** Adapter class for languages that only contain translations upto 
  *  version 1.8.0. 
  */
-class TranslatorAdapter_1_8_0 : public TranslatorAdapterBase
+class TranslatorAdapter_1_8_0 : public TranslatorAdapter_1_8_2
 {
   public:
     virtual QCString updateNeededMessage()
Index: translator_cn.h
===================================================================
RCS file: /cygdrive/d/cvs_doxygen/doxygen/doxygen/src/translator_cn.h,v
retrieving revision 1.1
diff -u -r1.1 translator_cn.h
--- translator_cn.h	22 May 2012 19:36:56 -0000	1.1
+++ translator_cn.h	16 Jun 2012 16:25:32 -0000
@@ -24,7 +24,7 @@
 */
 #define CN_SPC " "
 
-class TranslatorChinese : public Translator
+class TranslatorChinese : public TranslatorAdapter_1_8_2
 {
   public:
     /*! Used for identification of the language. The identification
Index: translator_cz.h
===================================================================
RCS file: /cygdrive/d/cvs_doxygen/doxygen/doxygen/src/translator_cz.h,v
retrieving revision 1.1
diff -u -r1.1 translator_cz.h
--- translator_cz.h	22 May 2012 19:36:56 -0000	1.1
+++ translator_cz.h	16 Jun 2012 14:23:07 -0000
@@ -83,7 +83,7 @@
 //    something else.  It is difficult to find the general translation
 //    for all kinds in the Czech language.
 
-class TranslatorCzech : public Translator
+class TranslatorCzech : public TranslatorAdapter_1_8_2
 {
   public:
     // --- Language control methods -------------------
Index: translator_de.h
===================================================================
RCS file: /cygdrive/d/cvs_doxygen/doxygen/doxygen/src/translator_de.h,v
retrieving revision 1.1
diff -u -r1.1 translator_de.h
--- translator_de.h	22 May 2012 19:36:57 -0000	1.1
+++ translator_de.h	16 Jun 2012 16:25:51 -0000
@@ -133,7 +133,7 @@
 #ifndef TRANSLATOR_DE_H
 #define TRANSLATOR_DE_H
 
-class TranslatorGerman : public Translator
+class TranslatorGerman : public TranslatorAdapter_1_8_2
 {
   public:
 
Index: translator_en.h
===================================================================
RCS file: /cygdrive/d/cvs_doxygen/doxygen/doxygen/src/translator_en.h,v
retrieving revision 1.1
diff -u -r1.1 translator_en.h
--- translator_en.h	22 May 2012 19:36:57 -0000	1.1
+++ translator_en.h	16 Jun 2012 14:12:18 -0000
@@ -1925,6 +1925,14 @@
     { return "Additional Inherited Members"; }
 
 //////////////////////////////////////////////////////////////////////////
+// new since 1.8.2
+//////////////////////////////////////////////////////////////////////////
+    /*! Put title of (svg) call graph. */
+    virtual QCString trCallGraphGraph()
+    { return "Call graph:"; }
+    /*! Put title of (svg) caller graph. */
+    virtual QCString trCallerGraphGraph()
+    { return "Caller graph:"; }
 
 };
 
Index: translator_eo.h
===================================================================
RCS file: /cygdrive/d/cvs_doxygen/doxygen/doxygen/src/translator_eo.h,v
retrieving revision 1.1
diff -u -r1.1 translator_eo.h
--- translator_eo.h	22 May 2012 19:36:57 -0000	1.1
+++ translator_eo.h	16 Jun 2012 16:26:12 -0000
@@ -42,7 +42,7 @@
  Translator class (by the local maintainer) when the localized
  translator is made up-to-date again.
 */
-class TranslatorEsperanto : public Translator
+class TranslatorEsperanto : public TranslatorAdapter_1_8_2
 {
   public:
 
Index: translator_es.h
===================================================================
RCS file: /cygdrive/d/cvs_doxygen/doxygen/doxygen/src/translator_es.h,v
retrieving revision 1.1
diff -u -r1.1 translator_es.h
--- translator_es.h	22 May 2012 19:36:57 -0000	1.1
+++ translator_es.h	16 Jun 2012 16:26:47 -0000
@@ -33,7 +33,7 @@
  */
 
 
-class TranslatorSpanish : public Translator
+class TranslatorSpanish : public TranslatorAdapter_1_8_2
 {
 
   public:
Index: translator_hr.h
===================================================================
RCS file: /cygdrive/d/cvs_doxygen/doxygen/doxygen/src/translator_hr.h,v
retrieving revision 1.1
diff -u -r1.1 translator_hr.h
--- translator_hr.h	22 May 2012 19:36:58 -0000	1.1
+++ translator_hr.h	16 Jun 2012 16:26:59 -0000
@@ -83,7 +83,7 @@
 #ifndef TRANSLATOR_HR_H
 #define TRANSLATOR_HR_H
 
-class TranslatorCroatian : public Translator
+class TranslatorCroatian : public TranslatorAdapter_1_8_2
 {
   private:
   
Index: translator_it.h
===================================================================
RCS file: /cygdrive/d/cvs_doxygen/doxygen/doxygen/src/translator_it.h,v
retrieving revision 1.1
diff -u -r1.1 translator_it.h
--- translator_it.h	22 May 2012 19:36:58 -0000	1.1
+++ translator_it.h	16 Jun 2012 16:27:04 -0000
@@ -85,7 +85,7 @@
 #ifndef TRANSLATOR_IT_H
 #define TRANSLATOR_IT_H
 
-class TranslatorItalian : public Translator
+class TranslatorItalian : public TranslatorAdapter_1_8_2
 {
   public:
 
Index: translator_nl.h
===================================================================
RCS file: /cygdrive/d/cvs_doxygen/doxygen/doxygen/src/translator_nl.h,v
retrieving revision 1.1
diff -u -r1.1 translator_nl.h
--- translator_nl.h	22 May 2012 19:36:59 -0000	1.1
+++ translator_nl.h	16 Jun 2012 14:13:25 -0000
@@ -1507,6 +1507,16 @@
     virtual QCString trAdditionalInheritedMembers()
     { return "Additionele Overge&euml;rfde Members"; }
 
+//////////////////////////////////////////////////////////////////////////
+// new since 1.8.2
+//////////////////////////////////////////////////////////////////////////
+    /*! Put title of (svg) call graph. */
+    virtual QCString trCallGraphGraph()
+    { return "Call graaf:"; }
+    /*! Put title of (svg) caller graph. */
+    virtual QCString trCallerGraphGraph()
+    { return "Caller graaf:"; }
+
 };
 
 #endif
Index: translator_pl.h
===================================================================
RCS file: /cygdrive/d/cvs_doxygen/doxygen/doxygen/src/translator_pl.h,v
retrieving revision 1.1
diff -u -r1.1 translator_pl.h
--- translator_pl.h	22 May 2012 19:36:59 -0000	1.1
+++ translator_pl.h	16 Jun 2012 16:27:19 -0000
@@ -22,7 +22,7 @@
 #ifndef TRANSLATOR_PL_H
 #define TRANSLATOR_PL_H
 
-class TranslatorPolish : public Translator
+class TranslatorPolish : public TranslatorAdapter_1_8_2
 {
   public:
 
Index: translator_sk.h
===================================================================
RCS file: /cygdrive/d/cvs_doxygen/doxygen/doxygen/src/translator_sk.h,v
retrieving revision 1.1
diff -u -r1.1 translator_sk.h
--- translator_sk.h	22 May 2012 19:37:00 -0000	1.1
+++ translator_sk.h	16 Jun 2012 16:27:25 -0000
@@ -30,7 +30,7 @@
 #ifndef TRANSLATOR_SK_H
 #define TRANSLATOR_SK_H
 
-class TranslatorSlovak : public Translator
+class TranslatorSlovak : public TranslatorAdapter_1_8_2
 {
   public:
     // --- Language control methods -------------------
Index: translatordecoder.h
===================================================================
RCS file: /cygdrive/d/cvs_doxygen/doxygen/doxygen/src/translatordecoder.h,v
retrieving revision 1.2
diff -u -r1.2 translatordecoder.h
--- translatordecoder.h	14 Jun 2012 16:56:54 -0000	1.2
+++ translatordecoder.h	16 Jun 2012 14:33:26 -0000
@@ -771,6 +771,14 @@
 
 
 //////////////////////////////////////////////////////////////////////////
+// new since 1.8.2
+//////////////////////////////////////////////////////////////////////////
+    QCString trCallGraphGraph()
+    { return toUtf8(m_translator->trCallGraphGraph()); }
+    QCString trCallerGraphGraph()
+    { return toUtf8(m_translator->trCallerGraphGraph()); }
+
+//////////////////////////////////////////////////////////////////////////
   private:
     Translator *m_translator;
     void *m_toUtf8;