diff -ur doxygen-1.8.0/qtools/qfile.h doxygen-1.8.0.modified/qtools/qfile.h
--- doxygen-1.8.0/qtools/qfile.h	2009-08-25 13:26:15.000000000 +0200
+++ doxygen-1.8.0.modified/qtools/qfile.h	2013-06-10 11:47:36.000000000 +0200
@@ -38,6 +38,8 @@
 #ifndef QFILE_H
 #define QFILE_H
 
+#include <inttypes.h>
+
 #ifndef QT_H
 #include "qiodevice.h"
 #include "qstring.h"
@@ -94,9 +96,9 @@
 
     int		handle() const;
 
-    int64       pos() const;
-    int64       toEnd();
-    bool        seek(int64 pos);
+    int64_t       pos() const;
+    int64_t       toEnd();
+    bool        seek(int64_t pos);
 
 protected:
     QString	fn;
diff -ur doxygen-1.8.0/qtools/qfile_unix.cpp doxygen-1.8.0.modified/qtools/qfile_unix.cpp
--- doxygen-1.8.0/qtools/qfile_unix.cpp	2009-08-25 13:26:15.000000000 +0200
+++ doxygen-1.8.0.modified/qtools/qfile_unix.cpp	2013-06-10 11:47:58.000000000 +0200
@@ -633,7 +633,7 @@
     return;
 }
 
-int64 QFile::pos() const
+int64_t QFile::pos() const
 {
   if (isOpen())
   {
@@ -643,7 +643,7 @@
   return -1;
 }
 
-int64 QFile::toEnd() 
+int64_t QFile::toEnd() 
 {
   if (isOpen())
   {
@@ -656,7 +656,7 @@
   return -1;
 }
 
-bool QFile::seek( int64 pos )
+bool QFile::seek( int64_t pos )
 {
   if (isOpen())
   {
diff -ur doxygen-1.8.0/qtools/qfile_win32.cpp doxygen-1.8.0.modified/qtools/qfile_win32.cpp
--- doxygen-1.8.0/qtools/qfile_win32.cpp	2010-06-09 15:35:04.000000000 +0200
+++ doxygen-1.8.0.modified/qtools/qfile_win32.cpp	2013-06-10 11:49:13.000000000 +0200
@@ -641,7 +641,7 @@
     return;
 }
 
-int64 QFile::pos() const
+int64_t QFile::pos() const
 {
   if (isOpen())
   {
@@ -651,7 +651,7 @@
   return -1;
 }
 
-int64 QFile::toEnd() 
+int64_t QFile::toEnd() 
 {
   if (isOpen())
   {
@@ -664,7 +664,7 @@
   return -1;
 }
 
-bool QFile::seek( int64 pos )
+bool QFile::seek( int64_t pos )
 {
   if (isOpen())
   {
diff -ur doxygen-1.8.0/qtools/qglobal.h doxygen-1.8.0.modified/qtools/qglobal.h
--- doxygen-1.8.0/qtools/qglobal.h	2011-05-18 18:56:01.000000000 +0200
+++ doxygen-1.8.0.modified/qtools/qglobal.h	2013-06-10 11:51:31.000000000 +0200
@@ -373,11 +373,8 @@
 typedef uchar	       *puchar;
 typedef const char     *pcchar;
 #if defined(_OS_WIN32_) && !defined(_CC_GNU_)
-typedef __int64            int64;
-typedef unsigned __int64   uint64;
-#else
-typedef long long          int64;
-typedef unsigned long long uint64;
+typedef __int64            int64_t;
+typedef unsigned __int64   uint64_t;
 #endif
 
 
diff -ur doxygen-1.8.0/src/entry.h doxygen-1.8.0.modified/src/entry.h
--- doxygen-1.8.0/src/entry.h	2012-02-24 14:45:56.000000000 +0100
+++ doxygen-1.8.0.modified/src/entry.h	2013-06-10 11:52:20.000000000 +0200
@@ -337,7 +337,7 @@
     SrcLangExt   m_lang;         //!< programming language in which this entry was found
 
     Entry       *m_info;
-    int64        m_offset;
+    int64_t        m_offset;
     bool         m_noLoad;
 };
 
diff -ur doxygen-1.8.0/src/filestorage.h doxygen-1.8.0.modified/src/filestorage.h
--- doxygen-1.8.0/src/filestorage.h	2012-01-29 16:12:55.000000000 +0100
+++ doxygen-1.8.0.modified/src/filestorage.h	2013-06-10 11:52:42.000000000 +0200
@@ -34,8 +34,8 @@
     int read(char *buf,uint size)        { return m_file.readBlock(buf,size); }
     int write(const char *buf,uint size) { assert(m_readOnly==FALSE); return m_file.writeBlock(buf,size); }
     bool open( int m )                   { m_readOnly = m==IO_ReadOnly; return m_file.open(m); }
-    bool seek(int64 pos)                 { return m_file.seek(pos); }
-    int64 pos() const                    { return m_file.pos(); }
+    bool seek(int64_t pos)                 { return m_file.seek(pos); }
+    int64_t pos() const                    { return m_file.pos(); }
     void close()                         { m_file.close(); }
     void setName( const char *name )     { m_file.setName(name); }
   private:
@@ -93,12 +93,12 @@
       m_off+=size; 
       return size; 
     }
-    bool seek(int64 pos)                 
+    bool seek(int64_t pos)                 
     { 
       m_off=pos; 
       return TRUE; 
     }
-    int64 pos() const                    
+    int64_t pos() const                    
     { 
       if (m_readOnly)
       {
--- doxygen-1.8.0/src/objcache.cpp	2012-01-29 16:12:58.000000000 +0100
+++ doxygen-1.8.0.modified/src/objcache.cpp	2013-06-10 12:20:46.000000000 +0200
@@ -174,7 +174,7 @@
   static bool isPtr64 = sizeof(addr)==8;
   if (isPtr64)
   {
-    uint64 key = (uint64)addr;
+    uint64_t key = (uint64_t)addr;
     // Thomas Wang's 64 bit Mix Function
     key += ~(key << 32);
     key ^=  (key >> 22);
--- doxygen-1.8.0/src/vhdlparser.y	2012-02-11 15:02:04.000000000 +0100
+++ doxygen-1.8.0.modified/src/vhdlparser.y	2013-06-10 12:35:13.000000000 +0200
@@ -376,7 +376,7 @@
 physical_literal_no_default : t_AbstractLit t_Identifier   { $$=$1+" "+$2; }
 
 idf_list : t_Identifier { $$=$1; }
-         | idf_list t_Comma t_Identifier { $$=$1+","+$3}
+         | idf_list t_Comma t_Identifier { $$=$1+","+$3; }
          ;
 
 /*------------------------------------------
@@ -464,7 +464,7 @@
               | t_PORT { currP=VhdlDocGen::PORT; }  interf_list t_Semicolon  { currP=0; }
               ;
 entity_decl_1 :  /* empty */  { $$=""; }
-              | t_GENERIC { currP=VhdlDocGen::GENERIC;parse_sec=GEN_SEC} interf_list t_Semicolon{ currP=0;parse_sec=0; }
+              | t_GENERIC { currP=VhdlDocGen::GENERIC;parse_sec=GEN_SEC; } interf_list t_Semicolon{ currP=0;parse_sec=0; }
               | t_GENERIC error t_Semicolon{ currP=0; }
               ;
 
@@ -1055,7 +1055,7 @@
 
 base_unit_decl: t_Identifier t_Semicolon { $$=$1; }
 
-secondary_unit_decl: t_Identifier t_EQSym physical_literal t_Semicolon { $$=$1+"="+$3 }
+secondary_unit_decl: t_Identifier t_EQSym physical_literal t_Semicolon { $$=$1+"="+$3; }
 
 unconstrained_array_definition: t_ARRAY t_LeftParen
                                 index_subtype_definition unconstrained_array_definition_1 t_RightParen t_OF
@@ -1067,8 +1067,8 @@
     }
 
 unconstrained_array_definition_1: { $$=""; }
-unconstrained_array_definition_1: unconstrained_array_definition_1 unconstrained_array_definition_2 { $$=$1+"  "+$2 }
-unconstrained_array_definition_2: t_Comma index_subtype_definition { $$=", "+$2 }
+unconstrained_array_definition_1: unconstrained_array_definition_1 unconstrained_array_definition_2 { $$=$1+"  "+$2; }
+unconstrained_array_definition_2: t_Comma index_subtype_definition { $$=", "+$2; }
 
 index_subtype_definition: mark t_RANGE t_Box { $$=$1+" range<> "; }
 