 PLATFORMS                       | 1 +
 addon/doxywizard/doxywizard.cpp | 2 +-
 configure                       | 3 +++
 doc/install.doc                 | 5 +++--
 qtools/qcstring.h               | 2 +-
 qtools/qfileinfo_win32.cpp      | 3 ++-
 src/doxygen.pro.in              | 2 +-
 src/objcache.cpp                | 2 +-
 8 files changed, 13 insertions(+), 7 deletions(-)

diff --git a/PLATFORMS b/PLATFORMS
index c358a1d..22a8d8c 100644
--- a/PLATFORMS
+++ b/PLATFORMS
@@ -29,3 +29,4 @@ sunos-g++
 ultrix-g++
 unixware-g++
 win32-g++
+win32-mingw
diff --git a/addon/doxywizard/doxywizard.cpp b/addon/doxywizard/doxywizard.cpp
index 9bdf39d..22e2384 100644
--- a/addon/doxywizard/doxywizard.cpp
+++ b/addon/doxywizard/doxywizard.cpp
@@ -525,7 +525,7 @@ void MainWindow::showHtmlOutput()
   // TODO: the following doesn't seem to work with IE
 #ifdef WIN32
   //QString indexUrl(QString::fromAscii("file:///"));
-  ShellExecute(NULL, L"open", fi.absoluteFilePath().utf16(), NULL, NULL, SW_SHOWNORMAL);
+  ShellExecute(NULL, L"open", (LPCWSTR)fi.absoluteFilePath().utf16(), NULL, NULL, SW_SHOWNORMAL);
 #else
   QString indexUrl(QString::fromAscii("file://"));
   indexUrl+=fi.absoluteFilePath();
diff --git a/configure b/configure
index b8555f1..78de009 100755
--- a/configure
+++ b/configure
@@ -266,6 +266,9 @@ if test -z "$f_platform"; then
     Cygwin:*|CYGWIN*)
       f_platform=win32-g++
       ;;
+    MINGW32_NT*)
+      f_platform=win32-mingw
+      ;;
     *MiNT:*)
       f_platform=m68k-atari-mint-g++
       ;;
diff --git a/doc/install.doc b/doc/install.doc
index 4eb0308..a4fe2f7 100644
--- a/doc/install.doc
+++ b/doc/install.doc
@@ -29,9 +29,10 @@ If you downloaded the source distribution, you need at least the
 following to build the executable:
 <ul>
 <li>The <a href="ftp://prep.ai.mit.edu/pub/gnu/">GNU</a> tools 
-    \c flex, \c bison and <code>GNU make</code>, and \c strip
+    \c flex, \c bison, \c libiconv and <code>GNU make</code>, and \c strip
     \addindex flex
     \addindex bison
+    \addindex libiconv
     \addindex make
     \addindex strip
 <li>In order to generate a \c Makefile for your platform, you need 
@@ -48,7 +49,7 @@ tools should be installed.
 <li>Qt Software's GUI toolkit 
     <a href="http://qt-project.org/">Qt</A>
     \addindex Qt
-    version 4.3 or higher.
+    version 4.3 or higher (but currently, Qt 5.x is not supported).
     This is needed to build the GUI front-end doxywizard. 
 <li>A \f$\mbox{\LaTeX}\f$ distribution: for instance
     <a href="http://www.tug.org/interest.html#free">TeX Live</a>
diff --git a/qtools/qcstring.h b/qtools/qcstring.h
index 8b652b4..f7d2c95 100644
--- a/qtools/qcstring.h
+++ b/qtools/qcstring.h
@@ -46,7 +46,7 @@
 #include <stdlib.h>
 #include <string.h>
 
-#if !defined(_OS_WIN32_)
+#if !defined(_OS_WIN32_) || defined(__MINGW32__)
 #include <stdint.h>
 #endif
 
diff --git a/qtools/qfileinfo_win32.cpp b/qtools/qfileinfo_win32.cpp
index 2e1ecae..1061fae 100644
--- a/qtools/qfileinfo_win32.cpp
+++ b/qtools/qfileinfo_win32.cpp
@@ -266,7 +266,8 @@ void QFileInfo::doStat() const
     }
 #else
     QString file = fn;
-    reslashify(QDir::cleanDirPath(file));
+    file = QDir::cleanDirPath(file);
+    reslashify(file);
 #ifdef QT_LARGEFILE_SUPPORT
     if ( _wstati64( (wchar_t*) file.ucs2(), b ) == -1 ) {
 #else
diff --git a/src/doxygen.pro.in b/src/doxygen.pro.in
index 15af1f5..d9589e7 100644
--- a/src/doxygen.pro.in
+++ b/src/doxygen.pro.in
@@ -20,7 +20,7 @@ HEADERS      =	doxygen.h
 SOURCES      =	main.cpp 
 unix:LIBS                  += -L../lib -ldoxygen -ldoxycfg -lqtools -lmd5 -lpthread %%SQLITE3_LIBS%% %%LIBCLANG_LIBS%%
 win32:INCLUDEPATH          += .
-win32-mingw:LIBS           += -L../lib -ldoxygen -ldoxycfg -lqtools -lmd5 -lpthread %%SQLITE3_LIBS%% %%LIBCLANG_LIBS%%
+win32-mingw:LIBS           += -L../lib -ldoxygen -ldoxycfg -lqtools -lmd5 -lpthread -llibiconv -lole32 %%SQLITE3_LIBS%% %%LIBCLANG_LIBS%%
 win32-msvc:LIBS            += qtools.lib md5.lib doxygen.lib doxycfg.lib shell32.lib iconv.lib
 win32-msvc:TMAKE_LFLAGS    += /LIBPATH:..\lib
 win32-borland:LIBS         += qtools.lib md5.lib doxygen.lib doxycfg.lib shell32.lib iconv.lib
diff --git a/src/objcache.cpp b/src/objcache.cpp
index 989811a..3a538a3 100644
--- a/src/objcache.cpp
+++ b/src/objcache.cpp
@@ -19,7 +19,7 @@
 #include <assert.h>
 #include <qglobal.h>
 #include "objcache.h"
-#if !defined(_OS_WIN32_)
+#if !defined(_OS_WIN32_) || defined(__MINGW32__)
 #include <stdint.h>
 #endif
 